import { compileString } from 'cherry-cljs';
import * as compilerSFC from '@vue/compiler-sfc';
export default function parse(input, options) {
    if (input.match(/<script[^>]+?lang=\"cljs\"/)) {
        const cljsScriptBlock = input.match(/(<script[^>]*?>)(.*?[^(?:<\/script>)]*?)(<\/script>)/s);
        const cljs = cljsScriptBlock[2];
        const jsx = compileString(cljs);
        const scriptOpen = cljsScriptBlock[1].replace(/lang=\"cljs\"/, 'lang="jsx"');
        const scriptClose = cljsScriptBlock[3];
        const inputWithJsxScriptBlock = input.replace(/<script[\s>].+?<\/script>/s, `${scriptOpen}${jsx}${scriptClose}`);
        return compilerSFC.parse(inputWithJsxScriptBlock, options);
    }
    else
        return compilerSFC.parse(input, options);
}
